log4cplus::helpers::SharedObject Class Reference

`#include <pointer.h>`

Inheritance diagram for log4cplus::helpers::SharedObject:
[legend]
Collaboration diagram for log4cplus::helpers::SharedObject:
[legend]

## Public Member Functions

void | addReference () const LOG4CPLUS_NOEXCEPT
void | removeReference () const

## Public Attributes

thread::Mutex | access_mutex

## Protected Member Functions

| SharedObject ()
| SharedObject (const SharedObject &)
| SharedObject (SharedObject &&)
virtual | ~SharedObject ()
SharedObject & | operator= (const SharedObject &) LOG4CPLUS_NOEXCEPT
SharedObject & | operator= (SharedObject &&) LOG4CPLUS_NOEXCEPT

## Detailed Description

Definition at line 53 of file pointer.h.

## Constructor & Destructor Documentation

## SharedObject() [1/3]

log4cplus::helpers::SharedObject::SharedObject | ( |  | ) |

inline protected

Definition at line 61 of file pointer.h.

References access_mutex, and SharedObject().

Referenced by operator=(), operator=(), SharedObject(), SharedObject(), and SharedObject().

## SharedObject() [2/3]

log4cplus::helpers::SharedObject::SharedObject | ( | const SharedObject & |  | ) |

inline protected

Definition at line 66 of file pointer.h.

References access_mutex, and SharedObject().

## SharedObject() [3/3]

log4cplus::helpers::SharedObject::SharedObject | ( | SharedObject && |  | ) |

inline protected

Definition at line 71 of file pointer.h.

References access_mutex, and SharedObject().

## ~SharedObject()

virtual log4cplus::helpers::SharedObject::~SharedObject | ( |  | ) |

protected virtual

## Member Function Documentation

## addReference()

void log4cplus::helpers::SharedObject::addReference | ( |  | ) | const

References LOG4CPLUS_NOEXCEPT.

Referenced by log4cplus::helpers::intrusive_ptr_add_ref().

## operator=() [1/2]

SharedObject & log4cplus::helpers::SharedObject::operator= | ( | const SharedObject & |  | ) |

inline protected

Definition at line 80 of file pointer.h.

References LOG4CPLUS_NOEXCEPT, and SharedObject().

## operator=() [2/2]

SharedObject & log4cplus::helpers::SharedObject::operator= | ( | SharedObject && |  | ) |

inline protected

Definition at line 81 of file pointer.h.

References LOG4CPLUS_NOEXCEPT, and SharedObject().

## removeReference()

void log4cplus::helpers::SharedObject::removeReference | ( |  | ) | const

References removeReference().

Referenced by log4cplus::helpers::intrusive_ptr_release(), and removeReference().

## Member Data Documentation

## access_mutex

thread::Mutex log4cplus::helpers::SharedObject::access_mutex

Definition at line 84 of file pointer.h.

Referenced by SharedObject(), SharedObject(), and SharedObject().

The documentation for this class was generated from the following file:

- pointer.h